
<center>

<div style="font-size: 24pt; padding-top: 15px" align="center">
Menu Builder for JSCookMenu
</div>

<hr />
<p>Please see the <a href="#help">description</a> below.</p>
Paste the menu here. (only the part starting with "[")<br />

<table bgcolor="#efebde">

<form>
<tr>

	<td colspan="5">
		<textarea id="importArea" wrap="off" rows="5" style="width: 100%; font-size: 70%"></textarea>
	</td>
	<td valign="top" align="center">
		<input type="button" value="import" onclick="mbImport ()" class="FormButton"/><br />
		<input type="button" value="import HTML" onclick="mbImportHTML ()" class="FormButton"/><br />
		<input type="reset" value="clear" class="FormButton"/>
	</td>

</tr>
</form>

<tr><td colspan="6"><hr /></td></tr>
<tr>
	<td>icon</td>
	<td>title</td>
	<td>url</td>
	<td>target</td>
	<td>description</td>
	<td></td>
</tr>

<form>
<tr>
	<td><input type="text" id="micon" size="5" /></td>
	<td><input type="text" id="mtitle" size="15" /></td>
	<td><input type="text" id="mlink" size="10" /></td>
	<td><input type="text" id="mtarget" size="5" value="_self" /></td>

	<td><input type="text" id="mdescript" size="10" /></td>
	<td align="center"><input type="reset" value="clear" class="FormButton" /></td>
</tr>
</form>

<tr><td colspan="6"><hr /></td></tr>

<form>
<tr><td width="80%" colspan="5">
		<select rows="1" style="font-family: courier; width: 100%">
		<option>0&nbsp;&nbsp;&nbsp;&nbsp;1&nbsp;&nbsp;&nbsp;&nbsp;2&nbsp;&nbsp;&nbsp;&nbsp;3&nbsp;&nbsp;&nbsp;&nbsp;4&nbsp;&nbsp;&nbsp;&nbsp;5&nbsp;&nbsp;&nbsp;&nbsp;6&nbsp;&nbsp;&nbsp;&nbsp;7&nbsp;&nbsp;&nbsp;&nbsp;8&nbsp;&nbsp;&nbsp;&nbsp;9</option>

		</select>
	</td>
	<td rowspan="2" valign="top" align="center">
		<input type="button" value="add node" onclick="mbAddNode ()" class="FormButton" /><br />
		<input type="button" value="add child" onclick="mbAddChild ()" class="FormButton" /><br />
		<input type="button" value="add split" onclick="mbAddSplit ()" class="FormButton" /><br />
		<input type="button" value="modify" onclick="mbModify ()" class="FormButton" /><br />
		<input type="button" value="move up" onclick="mbMoveUp ()" class="FormButton" /><br />
		<input type="button" value="move down" onclick="mbMoveDown ()" class="FormButton" /><br />

		<input type="button" value="indent >>" onclick="mbIndent ()" class="FormButton" /><br />
		<input type="button" value="<< unindent" onclick="mbUnindent ()" class="FormButton" />
		<hr />
		<input type="button" value="delete" onclick="mbDelete ()" class="FormButton" />
		<hr />
		<input type="reset" value="clear" onclick="mbClearTree ()" class="FormButton" />
	</td>
				</tr>
				<tr>

	<td width="80%" id="treeTD" colspan="5">
		<select id="treeArea" size="20" style="font-family: courier; width: 100%">
		</select>
	</td>
</tr>
</form>

<tr><td colspan="6"><hr /></td></tr>

<form>
<tr>
	<td colspan="5">

		<textarea id="codeArea" wrap="off" rows="5" style="width: 100%; font-size: 70%"></textarea>
	</td>
	<td valign="top" align="center">
		<input type="button" value="show code" onclick="mbShowCode ()" class="FormButton" /><br />
		<input type="button" value="show HTML" onclick="mbShowHTML ()" class="FormButton" /><br />
		<input type="reset" value="clear" class="FormButton" />
	</td>
</tr>
</form>

</table>

<hr />
<div style="font-size: 10pt; padding-top: 15px;" align="left">
<a id="help" name="help"></a>
<h3>Help</h3>
<ul>
	<li>this menu builder cannot handle custom actions.
	</li>
	<li>save your work by clicking on the "show code" button,
	copying the content in the code box to clipboard, and then
	pasting it into your favorite text editor.
	</li>
	<li style="color: #990000">you will lose your work if you go
	to other web pages in this window.
	</li>

	<li>save often.
	</li>
	<li>use the "import" button to load your previous work.
	</li>
	<li>although JSCookTree 2.0 share the same tree format as JSCookMenu and
	you can use this menu builder for it, it cannot handle menu splits.
	</li>
	<li>if there are single quotes (<code>'</code>) in your text, write <code>\'</code>
	instead.
	</li>

	<li>this code is copyrighted by Heng Yuan under <a href="http://www.opensource.org/licenses/mit-license.php">MIT license</a>.
	</li>
	<li>you may convert the code for other platforms, softwares
	as long as proper credits are mentioned.  send me an email/copy
	of the work.
	</li>
</ul>
</div>

<div id="tmpForImport" style="display: none; width: 1px; height: 1px;">
</div>

<script language="JavaScript" type="text/javascript"><!--
var _mbTree = null;			// the tree representation
var _mbList = null;			// the list representation

//
// a "simple" tree class w/ back edges
//
function mbTreeNode (micon, mtitle, mlink, mtarget, mdescript)
{
	this.parentNode = null;
	this.firstChild = null;
	this.lastChild = null;
	this.prevSibling = null;
	this.nextSibling = null;

	this.micon = micon;
	this.mtitle = mtitle;
	this.mlink = mlink;
	this.mtarget = mtarget;
	this.mdescript = mdescript;

	//
	// attach a node at the end of the child tree
	//
	// if childNode is null or undefined, nothing is done.
	//
	this.addChild = function (childNode)
	{
		if (!childNode)
			return;
		if (this.lastChild == null)
		{
			this.firstChild = childNode;
			this.lastChild = childNode;
			childNode.parentNode = this;
		}
		else
		{
			this.lastChild.nextSibling = childNode;
			childNode.prevSibling = this.lastChild;
			this.lastChild = childNode;
			childNode.parentNode = this;
		}
	};

	//
	// assumed that this. prevSibling, nextSibling are null
	//
	this.insertBefore = function (node)
	{
		this.parentNode = node.parentNode;
		if (node.prevSibling)
		{
			node.prevSibling.nextSibling = this;
			this.prevSibling = node.prevSibling;
		}
		else
		{
			if (node.parentNode &&
				node.parentNode.firstChild == node)
				node.parentNode.firstChild = this;
		}
		this.nextSibling = node;
		node.prevSibling = this;
	};

	//
	// assumed that this. prevSibling, nextSibling are null
	//
	this.insertAfter = function (node)
	{
		this.parentNode = node.parentNode;
		if (node.nextSibling)
		{
			node.nextSibling.prevSibling = this;
			this.nextSibling = node.nextSibling;
		}
		else
		{
			if (node.parentNode &&
				node.parentNode.lastChild == this)
				node.parentNode.lastChild = this;
		}
		this.prevSibling = node;
		node.nextSibling = this;
	};

	//
	// remove a this node from other tree structures
	//
	this.remove = function ()
	{
		if (this.parentNode)
		{
			var parentNode = this.parentNode;
			if (parentNode.firstChild == this)
				parentNode.firstChild = this.nextSibling;
			if (parentNode.lastChild == this)
				parentNode.lastChild = this.prevSibling;
		}

		if (this.prevSibling)
			this.prevSibling.nextSibling = this.nextSibling;
		if (this.nextSibling)
			this.nextSibling.prevSibling = this.prevSibling;

		this.parentNode = null;
		this.prevSibling = null;
		this.nextSibling = null;
	};

	//
	// generate a preorder list of nodes
	//
	this.generateList = function (list)
	{
		list.push (this);
		var child;
		for (child = this.firstChild; child != null; child = child.nextSibling)
			child.generateList (list);
	};

	//
	// generate a preorder list of <option> for <select>
	//
	this.generateOption = function (indent)
	{
		var str = '<option onmouseover="mbOptionHover (this)" onmouseout="mbClearStatus ()">' + indent;
		if (this.micon == _cmSplit)
			return str + '--------------</option>\n';
		str += this.mtitle + '</option>\n';
		var child;
		for (child = this.firstChild; child != null; child = child.nextSibling)
			str += child.generateOption (indent + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
		return str;
	};

	//
	// generate the correspond tree/menu code for JSCookMenu/JSCookTree
	//
	this.generateCode = function (indent)
	{
		var str = indent;

		if (this.micon == _cmSplit)
		{
			if (this.nextSibling)
				return str + '_cmSplit,\n';
			else
				return str + '_cmSplit\n';
		}

		str += '[';
		str += (this.micon == null) ? 'null,' : '\'' + this.micon + '\',';
		str += (this.mtitle == null) ? 'null,' : '\'' + this.mtitle + '\',';
		str += (this.mlink == null) ? 'null,' : '\'' + this.mlink + '\',';
		str += (this.mtarget == null) ? 'null,' : '\'' + this.mtarget + '\',';
		str += (this.mdescript == null) ? 'null' : '\'' + this.mdescript + '\'';

		if (this.firstChild)
			str += ',\n';
		var child;
		for (child = this.firstChild; child != null; child = child.nextSibling)
			str += child.generateCode (indent + '\t');
		if (this.firstChild)
			str += indent;

		if (this.nextSibling)
			str += '],\n';
		else
			str += ']\n';
		return str;
	};
	//
	// generate the correspond tree/menu code for JSCookMenu/JSCookTree
	//
	this.generateHTML = function (indent)
	{
		var str = indent;

		if (this.micon == _cmSplit)
			return str + '<li></li>\n';

		str += '<li>';
		str += '<span>' + ((this.micon == null) ? '' : this.micon) + '</span>';
		if (this.mlink == null)
		{
			str += '<span>' + this.mtitle + '</span>\n';
		}
		else
		{
			str += '<a href="' + this.mlink + '"';
			if (this.mdescript != null)
				str += ' mtitle="' + this.mdescript + '"';
			if (this.mtarget != null)
				str += ' mtarget="' + this.mtarget + '"';
			str += '>';
			str += this.mtitle;
			str += '</a>\n';
		}
		if (this.firstChild)
		{
			var child;
			var childIndent = indent + '\t';
			var liIndent = childIndent + '\t';
			str += childIndent + '<ul>\n';
			for (child = this.firstChild; child != null; child = child.nextSibling)
				str += child.generateHTML (liIndent);
			str += childIndent + '</ul>\n';
		}
		str += indent + '</li>\n';
		return str;
	};
}

//
// import tree
//
function mbImport ()
{
	try
	{
		var obj = cmGetObject ('importArea');
		var tmpTree = null;
		eval ('tmpTree = ' + obj.value);
		tmpTree = mbConvertTree (tmpTree);

		_mbTree = tmpTree;
		mbShowTree ();
	}
	catch (ex)
	{
		alert ('Error Countered.');
		return;
	}
}

//
// import tree from html
//
function mbImportHTML ()
{
	try
	{
		var obj = cmGetObject ('importArea');
		var divNode = cmGetObject ('tmpForImport');
		divNode.innerHTML = obj.value;
		var dom;
		for (dom = divNode.firstChild; dom; dom = dom.nextSibling)
		{
			if (!dom.tagName)
				continue;
			var tag = dom.tagName.toLowerCase ();
			if (tag != 'ul' && tag != 'ol')
				continue;
			break;
		}
		var tmpTree = cmDrawFromTextSubMenu (dom);
		divNode.innerHTML = '';
		tmpTree = mbConvertTree (tmpTree);
		_mbTree = tmpTree;
		mbShowTree ();
	}
	catch (ex)
	{
		alert ('Error Countered: ' + ex);
		return;
	}
}

//
// convert JSCookMenu/JSCookTree representation to internal representation
//
function mbConvertTree (tree)
{
	var i;
	var firstNode = null;
	var lastNode = null;
	var thisNode = null;
	for (i = 0; i < tree.length; ++i)
	{
		thisNode = mbConvertTreeSub (tree[i]);
		if (firstNode == null)
			firstNode = thisNode;
		if (lastNode)
			thisNode.insertAfter (lastNode);
		lastNode = thisNode;
	}
	return firstNode;
}

function mbConvertTreeSub (tree)
{
	if (tree == _cmSplit)
		return new mbTreeNode (_cmSplit, null, null, null, null);
	if (!tree)
		return null;
	var tmpTree = new mbTreeNode (tree[0], tree[1], tree[2], tree[3], tree[4]);
	var i;
	for (i = 5; i < tree.length; ++i)
		tmpTree.addChild (mbConvertTreeSub (tree[i]));
	return tmpTree;
}

//
// shows the current structure from scratch
//
function mbShowTree ()
{
	_mbList = new Array ();	// clear the old tree list representation
	var str = '';

	if (_mbTree)
	{
		var tmpTree;
		for (tmpTree = _mbTree; tmpTree; tmpTree = tmpTree.nextSibling)
		{
			tmpTree.generateList (_mbList);
			str += tmpTree.generateOption ('');
		}
	}
	str = '<select id="treeArea" onchange="mbSelectOnChange ()" size="20" style="font-family: courier; width: 100%">' + str +
		  '</select>';
	cmGetObject ('treeTD').innerHTML = str;
}

//
// clear the tree
//
function mbClearTree ()
{
	_mbTree = null;
	mbShowTree ();
}

//
// show the code for the current tree
//
function mbShowCode ()
{
	var str = '';
	if (_mbTree)
	{
		var tmpTree;
		for (tmpTree = _mbTree; tmpTree; tmpTree = tmpTree.nextSibling)
			str += tmpTree.generateCode ('\t');
	}
	str = '[\n' + str + '];\n';
	cmGetObject ('codeArea').value = str;
}

//
// show the HTML for the current tree
//
function mbShowHTML ()
{
	var str = '';
	if (_mbTree)
	{
		var tmpTree;
		for (tmpTree = _mbTree; tmpTree; tmpTree = tmpTree.nextSibling)
			str += tmpTree.generateHTML ('\t');
	}
	str = '<ul>\n' + str + '</ul>\n';
	cmGetObject ('codeArea').value = str;
}

//
// return the selected node in 'treeArea'
//
function mbGetSelectedIndex ()
{
	var obj = cmGetObject ('treeArea');
	if (obj.selectedIndex < 0 || obj.selectedIndex >= obj.length)
		return -1;
	return obj.selectedIndex;
}

//
// set the selected node in 'treeArea'
//
function mbSetSelectedIndex (index)
{
	var obj = cmGetObject ('treeArea');
	if (index < 0 || index >= obj.length)
		return false;
	obj.selectedIndex = index;
	return true;
}

//
// get the # of child nodes plus itself
//
function mbGetNodeLength (node)
{
	if (node == undefined)
		return 0;
	if (node == _cmSplit)
		return 1;
	var len = 1;
	if (node.length > 5)
	{
		var i;
		for (i = 5; i < node.length; ++i)
			len += mbGetNodeLength (node[i]);
	}
	return len;
}

//
// add a node
//
function mbAddNode ()
{
	var mtitle = cmGetObject ('mtitle').value;
	if (!mtitle)
		return;

	var micon = cmGetObject ('micon').value;
	var mlink = cmGetObject ('mlink').value;
	var mtarget = cmGetObject ('mtarget').value;
	var mdescript = cmGetObject ('mdescript').value;

	if (!micon) micon = null;
	if (!mlink) mlink = null;
	if (!mlink || !mtarget) mtarget = null;
	if (!mdescript) mdescript = null;

	var tmpNode = new mbTreeNode (micon, mtitle, mlink, mtarget, mdescript);

	var index = mbGetSelectedIndex ();
	if (!_mbTree)
	{
		_mbTree = tmpNode;
	}
	else if (index < 0)
	{
		tmpNode.insertAfter (_mbList[_mbList.length - 1]);
	}
	else
	{
		tmpNode.insertAfter (_mbList[index]);
	}
	mbShowTree ();
	mbSetSelectedIndex (index + 1);
}

//
// add a child node
//
function mbAddChild ()
{
	var mtitle = cmGetObject ('mtitle').value;
	if (!mtitle)
		return;

	var micon = cmGetObject ('micon').value;
	var mlink = cmGetObject ('mlink').value;
	var mtarget = cmGetObject ('mtarget').value;
	var mdescript = cmGetObject ('mdescript').value;

	if (!micon) micon = null;
	if (!mlink) mlink = null;
	if (!mlink || !mtarget) mtarget = null;
	if (!mdescript) mdescript = null;

	var tmpNode = new mbTreeNode (micon, mtitle, mlink, mtarget, mdescript);

	var index = mbGetSelectedIndex ();
	if (!_mbTree)
	{
		_mbTree = tmpNode;
	}
	else if (index < 0)
	{
		tmpNode.insertAfter (_mbList[_mbList.length - 1]);
	}
	else
	{
		_mbList[index].addChild (tmpNode);
	}
	mbShowTree ();
	mbSetSelectedIndex (index);
}

//
// add a menu split
//
function mbAddSplit ()
{
	var tmpNode = new mbTreeNode (_cmSplit, null, null, null, null);

	var index = mbGetSelectedIndex ();
	if (!_mbTree)
	{
		_mbTree = tmpNode;
	}
	else if (index < 0)
	{
		tmpNode.insertAfter (_mbList[_mbList.length - 1]);
	}
	else
	{
		tmpNode.insertAfter (_mbList[index]);
	}
	mbShowTree ();
	mbSetSelectedIndex (mbGetNodeIndex (tmpNode));
}

//
// change the current node
//
function mbModify ()
{
	var index = mbGetSelectedIndex ();
	if (!_mbTree || index < 0)
		return;

	var mtitle = cmGetObject ('mtitle').value;
	if (!mtitle)
		return;

	var micon = cmGetObject ('micon').value;
	var mlink = cmGetObject ('mlink').value;
	var mtarget = cmGetObject ('mtarget').value;
	var mdescript = cmGetObject ('mdescript').value;

	if (!micon) micon = null;
	if (!mlink) mlink = null;
	if (!mlink || !mtarget) mtarget = null;
	if (!mdescript) mdescript = null;

	var node = _mbList[index];

	node.micon = micon;
	node.mtitle = mtitle;
	node.mlink = mlink;
	node.mtarget = mtarget;
	node.mdescript = mdescript;

	mbShowTree ();
	mbSetSelectedIndex (index);
}

//
// move the current node up
//
function mbMoveUp ()
{
	var index = mbGetSelectedIndex ();
	if (!_mbTree || index < 0)
		return;

	var node = _mbList[index];

	if (!node.prevSibling)
		return;
	var prevSibling = node.prevSibling;
	node.remove ();
	node.insertBefore (prevSibling);

	if (_mbTree == prevSibling)
		_mbTree = node;

	mbShowTree ();
	mbSetSelectedIndex (mbGetNodeIndex (node));
}

//
// move the current node down
//
function mbMoveDown ()
{
	var index = mbGetSelectedIndex ();
	if (!_mbTree || index < 0)
		return;

	var node = _mbList[index];

	if (!node.nextSibling)
		return;
	var nextSibling = node.nextSibling;
	node.remove ();
	node.insertAfter (nextSibling);

	if (_mbTree == node)
		_mbTree = nextSibling;

	mbShowTree ();
	mbSetSelectedIndex (mbGetNodeIndex (node));
}

//
// indent the current node
//
function mbIndent ()
{
	var index = mbGetSelectedIndex ();
	if (index < 0)
		return;

	var node = _mbList[index];

	if (!node.prevSibling || node.prevSibling.micon == _cmSplit)
		return;

	var prevSibling = node.prevSibling;

	node.remove ();
	prevSibling.addChild (node);

	mbShowTree ();
	mbSetSelectedIndex (mbGetNodeIndex (node));
}

//
// unindent the current node
//
function mbUnindent ()
{
	var index = mbGetSelectedIndex ();
	if (index < 0)
		return;

	var node = _mbList[index];

	if (!node.parentNode)
		return;

	var parentNode = node.parentNode;

	node.remove ();

	node.insertAfter (parentNode);

	mbShowTree ();
	mbSetSelectedIndex (mbGetNodeIndex (node));
}

//
// delete the current node
//
function mbDelete ()
{
	var index = mbGetSelectedIndex ();
	if (index < 0)
		return;

	var node = _mbList[index];

	if (_mbTree == node)
		_mbTree = node.nextSibling;

	node.remove ();
	mbShowTree ();
	if (!mbSetSelectedIndex (index))
		mbSetSelectedIndex (index - 1);
}

//
// find the index of a node in _mbList
//
function mbGetNodeIndex (node)
{
	var i;
	for (i = 0; i < _mbList.length; ++i)
		if (_mbList[i] == node)
			return i;
	return -1;
}

//
// show the mdescription of the current item being hovered
//
function mbOptionHover (obj)
{
	var mdescript;
	var node = _mbList[obj.index];
	if (node.micon == _cmSplit)
		mdescript = 'menu split';
	else
		mdescript = node.micon + ',' + node.mtitle + ',' + node.mlink + ',' + node.mtarget + ',' + node.mdescript;
	window.defaultStatus = mdescript;
}

//
// clear the status
//
function mbClearStatus ()
{
	window.defaultStatus = '';
}

//
// when user selected something in <select>
//
function mbSelectOnChange ()
{
	var index = mbGetSelectedIndex ();
	var node = _mbList[index];
	if (node.micon == _cmSplit)
		return;
	cmGetObject ('micon').value = node.micon ? node.micon : '';
	cmGetObject ('mtitle').value = node.mtitle ? node.mtitle : '';
	cmGetObject ('mlink').value = node.mlink ? node.mlink : '';
	cmGetObject ('mtarget').value = node.mtarget ? node.mtarget : '';
	cmGetObject ('mdescript').value = node.mdescript ? node.mdescript : '';
}

/*
	Menu Builder for JSCookMenu and JSCookTree
		v1.0. (c) Copyright 2002 by Heng Yuan

	Permission is hereby granted, free of charge, to any person obtaining a
	copy of this software and associated documentation files (the "Software"),
	to deal in the Software without restriction, including without limitation
	the rights to use, copy, modify, merge, publish, distribute, sublicense,
	and/or sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included
	in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	ITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	DEALINGS IN THE SOFTWARE.
*/
--></script>

<div align="center">
<p>(c) Copyright 2002-2007 Heng Yuan. All rights reserved.</p>
</div>
</center>
